hdu 5045(状态压缩dp)

来源:互联网 发布:udp端口范围 编辑:程序博客网 时间:2024/06/11 11:24

  Contest

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others


Problem Description
In the ACM International Collegiate Programming Contest, each team consist of three students. And the teams are given 5 hours to solve between 8 and 12 programming problems.

On Mars, there is programming contest, too. Each team consist of N students. The teams are given M hours to solve M programming problems. Each team can use only one computer, but they can’t cooperate to solve a problem. At the beginning of the ith hour, they will get the ith programming problem. They must choose a student to solve this problem and others go out to have a rest. The chosen student will spend an hour time to program this problem. At the end of this hour, he must submit his program. This program is then run on test data and can’t modify any more.

Now, you have to help a team to find a strategy to maximize the expected number of correctly solved problems.

For each problem, each student has a certain probability that correct solve. If the ith student solve the jth problem, the probability of correct solve is Pij .

At any time, the different between any two students’ programming time is not more than 1 hour. For example, if there are 3 students and there are 5 problems. The strategy {1,2,3,1,2}, {1,3,2,2,3} or {2,1,3,3,1} are all legal. But {1,1,3,2,3},{3,1,3,1,2} and {1,2,3,1,1} are all illegal.

You should find a strategy to maximize the expected number of correctly solved problems, if you have know all probability
 

Input
The first line of the input is T (1 ≤ T ≤ 20), which stands for the number of test cases you need to solve.

The first line of each case contains two integers N ,M (1 ≤ N ≤ 10,1 ≤ M ≤ 1000),denoting the number of students and programming problem, respectively.

The next N lines, each lines contains M real numbers between 0 and 1 , the jth number in the ith line is Pij .
 

Output
For each test case, print a line “Case #t: ”(without quotes, t means the index of the test case) at the beginning. Then a single real number means the maximal expected number of correctly solved problems if this team follow the best strategy, to five digits after the decimal point. Look at the output for sample input for details.
 

Sample Input
12 30.6 0.3 0.40.3 0.7 0.9
 

Sample Output
Case #1: 2.20000
 

思路:

因为限制条件,所以前n道题,必须分给n个人一人一道,那么每人只能做一次;

那么用状态压缩表示哪些人做过了;

比如5个人00110;那么下一道题就可以选择剩下的3个人做,并且比较出一个最优的选择;

当状态变成11111时,就要重新置零;

所以用一个dp[i][j]表示前i道题,已经做的人的状态是j;


AC:

#include<iostream>#include<cstdio>#include<cstring>#include<algorithm>using namespace std;int n,m;double p[15][1005];double dp[1005][1<<10];int main(){int t,cas = 1;scanf("%d",&t);while(t--){scanf("%d%d",&n,&m);for(int i = 0; i < n; i++)for(int j = 0; j < m; j++)scanf("%lf",&p[i][j]);for(int i = 0; i <= m; i++) for(int j = 0 ; j < (1 << n); j++)dp[i][j] = -1.0;dp[0][0] = 0;for(int i = 0; i < m; i++)for(int k = 0; k < (1<<n); k++){if(dp[i][k] == -1) continue;for(int j = 0; j < n; j++){int tmp = 1 << j;if(k & tmp) continue;int s = k | tmp;if(s == (1 << n) - 1) s = 0;dp[i+1][s] = max(dp[i+1][s],dp[i][k]+p[j][i]);}}double ans = 0;for(int i = 0; i < (1<<n); i++)ans = max(ans,dp[m][i]);printf("Case #%d: %.5f\n",cas++,ans);}return 0;}



0 0